/** @file counter_coverage.h
 * This file contains coverage class description.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#pragma once

#include <hw/model.hpp>
#include <ts/coverage.hpp>
#include <tracer/tracer.hpp>

namespace cpptesk {
namespace examples {
namespace counter {

class Counter;

class CounterCoverage {
public:
    CounterCoverage(Counter &counter): counter(counter) {}

    cpptesk::tracer::coverage::CoverageTracker coverageTracker;

    DEFINE_ENUMERATED_COVERAGE(Counter_BitSet, "counter value", (
                               (I0, "zero"),
                               (I1, "one"),
                               (I2, "two"),
                               (I3, "three"),
                               (I4, "four"),
                               (I5, "five"),
                               (I6, "six"),
                               (I7, "seven")
            ));

    Counter_BitSet cov_BitSet(void) const;

    void out_cov(void);

protected:
    Counter &counter;
};

}}}

