/*
 * Generated by veritool: Copyright (c) 2009-2011 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 *
 * http://hardware.ispras.ru
 */

#include <vpi_systf.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>

#include <ts/scenario.h>
#include <utils/testreg.h>
#include <sync.h>

/* Create new source file with code like this:

   #include <utils/testreg.h>

   extern TestScenario example1_scen;
   extern TestScenario example2_scen;
   ClassOfScenario example3_scen;

   TEST_REGISTRY_BEGIN
   REGISTER_CTESK_TEST(example1_scen, engine::fsm, "")
   REGISTER_CTESK_TEST(example2_scen, engine::rnd, "")
   REGISTER_TEST(example3_scen, engine::rnd, NULL)
   TEST_REGISTRY_END
*/

char scen_argv[SCEN_ARGV_LENGTH];

////////////////////////////////////////////////////////////////////////////////
// VPI Tasks and Functions
////////////////////////////////////////////////////////////////////////////////
int startscen(bool netscen, char* name, char* params)
{
    int scen_number = find_scenario_TestRegistry(name, params);

    if(test_registry[scen_number].testType == CTESK) {
        TestScenario* ctest = (TestScenario*)test_registry[scen_number].testScenario;
        set_scenario_wrapper(ctest, test_registry[scen_number].testEngine, params, netscen);
        return start_scenario_with_wrapper(scenario_wrapper);
    }
#ifdef __cplusplus
    else if(test_registry[scen_number].testType == CPPTESK) {
        CppTestScenario* cpptest = ((cpptesk::ts::ScenarioBase*)test_registry[scen_number].testScenario)->getTestScenario();
        set_scenario_wrapper(cpptest, test_registry[scen_number].testEngine, params, netscen);
        return start_scenario_with_wrapper(scenario_wrapper_cpp);
    }
#endif
    else {
        assert(false);
        return 1;
    }
}

extern "C" {
int calltf_set_scenario(char* user_data)
{
    s_vpi_value value;
    vpiHandle obj = vpi_handle(vpiSysTfCall, NULL);

    assert(obj != NULL);
    if(user_data == NULL) {} // TBD

    if(obj != NULL)
    {
        bool netscen = false;
        vpiHandle itr = vpi_iterate(vpiArgument, obj);

        vpiHandle arg = vpi_scan(itr);
        value.format = vpiStringVal;
        vpi_get_value(arg, &value);
        if(*value.value.str == 1)
            netscen = true;

        arg = vpi_scan(itr);
        vpi_get_value(arg, &value);
        strcpy(scen_argv, value.value.str);

        arg = vpi_scan(itr);
        vpi_get_value(arg, &value);

        vpi_free_object(obj);
        vpi_free_object(itr);
        vpi_free_object(arg);

        return startscen(netscen, value.value.str, scen_argv);
    }

    return 0;
}

int calltf_call_ts(char* user_data)
{
    if(user_data == NULL) {} // TBD
    apply_check();
    return 0;
}
}

////////////////////////////////////////////////////////////////////////////////
// Registration of VPI Tasks and Functions
////////////////////////////////////////////////////////////////////////////////
static void register_calltf_set_scenario(void)
{
    s_vpi_systf_data tf_data;
    #ifdef IEEE_1364_2001
        vpiHandle tf_handle;
    #endif

    tf_data.type        = vpiSysTask;
    tf_data.sysfunctype = 0;
    tf_data.tfname      = TF_NAME_SET_SCENARIO;
    tf_data.calltf      = calltf_set_scenario;
    tf_data.compiletf   = NULL;
    tf_data.sizetf      = NULL;
    tf_data.user_data   = NULL;

    #ifndef IEEE_1364_2001
        vpi_register_systf(&tf_data);
    #else
        tf_handle = vpi_register_systf(&tf_data);
        vpi_free_object(tf_handle);
    #endif
}

static void register_calltf_call_ts(void)
{
    s_vpi_systf_data tf_data;
    #ifdef IEEE_1364_2001
        vpiHandle tf_handle;
    #endif

    tf_data.type        = vpiSysTask;
    tf_data.sysfunctype = 0;
    tf_data.tfname      = TF_NAME_CALL_TS;
    tf_data.calltf      = calltf_call_ts;
    tf_data.compiletf   = NULL;
    tf_data.sizetf      = NULL;
    tf_data.user_data   = NULL;

    #ifndef IEEE_1364_2001
        vpi_register_systf(&tf_data);
    #else
        tf_handle = vpi_register_systf(&tf_data);
        vpi_free_object(tf_handle);
    #endif
}
