/*Copyright 2010-2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: 
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include <hw/event.hpp>
#include <hw/debug.hpp>

#include <hw/diagnostics/error_model.hpp>
#include <hw/diagnostics/reaction_set.hpp>


namespace cpptesk {
namespace hw {
namespace diagnostics {

class Diagnostics 
{
public:

    Diagnostics(const std::vector<Reaction> &_reaction)
    {  
        // Get reactions for diagnostic
        _reactionSet.initialization(_reaction);
    }

    virtual ~Diagnostics()
    {  //Empty
    }

    void clearReaction();

    void run();
     
    void printVector();
    void printFullVector();
    
private:    
    ErrorModel _errorModel;
    ReactionSet _reactionSet;
};

}}}
