/*Copyright 2010-2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: 
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include "hw/event.hpp"

namespace cpptesk {
namespace hw {
namespace diagnostics {

class TransformUnit
{
public:

  TransformUnit() {}
  virtual ~TransformUnit() {}

  void addReaction1(Reaction *_reaction)
  {
    _reaction_1 = _reaction;
  }

  void addReaction2(Reaction *_reaction)
  {
    _reaction_2 = _reaction;
  }

  Reaction getReaction1()
  {
    return *_reaction_1;
  }

  Reaction getReaction2()
  {
    return *_reaction_2;
  }

private:
  Reaction *_reaction_1, *_reaction_2;
};

}}}
