/*
 * Copyright 2010-2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Kamkin (kamkin@ispras.ru)
// SYNOPSIS: Singleton 
///////////////////////////////////////////////////////////////////////////////

#pragma once

namespace cpptesk {
namespace hw {

template<class T>
class Singleton
{
public:
    virtual ~Singleton();

    static T& get();

protected:
    Singleton();

private:
    static T *_instance;
};

template<class T>
Singleton<T>::Singleton()
{
}

template<class T>
Singleton<T>::~Singleton()
{
    if(_instance)
        { delete _instance; }
}

template<class T>
T* Singleton<T>::_instance = 0;

template<class T>
T& Singleton<T>::get()
{
    if(!_instance)
        { _instance = new T(); }

    return *_instance;
}

}} // cpptesk::hw

