#!/bin/sh
echo NODES COMPUTERS=$COMPUTERS TESTRUNS_DIR=$TESTRUNS_DIR TESTRUN=$TESTRUN TESTNAME=$TESTNAME

CLUSTER_DIR=$CONFIG_DIR/clusters/$CLUSTER
# load common functions & variables
. $CLUSTER_DIR/cluster.conf

FUNCTIONS_DIR=`dirname $0`
. $FUNCTIONS_DIR/functions.sh

TESTRUN_DIR=$TESTRUNS_DIR/$TESTRUN
NODEDIR=$CLUSTER_DIR/$NODES_DIR
NODE_CFG=$TESTRUN_DIR/nodes.cfg

rm -f $NODE_CFG
mkdir -p $NODEDIR

NODEINDEX=0
NODECOUNT=0
while [ $NODEINDEX -lt $NODE_TOTAL ]
do
    TMP_MCC_PORT=$(($MCC_PORT + $NODEINDEX))
    TMP_SYNC_PORT=$(($SYNC_PORT + $NODEINDEX))

    NODEFILE=$NODEDIR/localhost_$TMP_MCC_PORT
    if [ -e "$NODEFILE" ]
    then
        echo NODE $NODEFILE IS BUSY
    else
        echo NODE $NODEFILE IS FREE
        if [ $COMPUTERS != 'all' ]
        then
            if [ $NODECOUNT -lt $COMPUTERS ]
            then
                echo $TESTRUN > $NODEFILE
                echo "localhost:$TMP_MCC_PORT,$TMP_SYNC_PORT" >> $NODE_CFG
                echo NODE $NODEFILE TAKEN
                NODECOUNT=$(($NODECOUNT + 1))
            fi
        fi
    fi
    NODEINDEX=$(($NODEINDEX + 1))
done

if [ $COMPUTERS = 'all' ]
then
    if [ -e "$NODE_CFG" ]
    then
        echo "" > /dev/null
    else
        echo "No free nodes" 2>&1
    fi
else
    if [ $NODECOUNT -lt $COMPUTERS ]
    then
        echo "Not enough free nodes" 2>&1
        exit 1
    fi
fi

echo NODES END
