#!/bin/sh

echo NODES COMPUTERS=$COMPUTERS TESTRUNS_DIR=$TESTRUNS_DIR TESTRUN=$TESTRUN TESTNAME=$TESTNAME

###############################################################################
CLUSTERDIR=$CONFIG_DIR/clusters/$CLUSTER
SRCNODEFILE=$CLUSTERDIR/hosts.conf
NODEDIR=$CLUSTERDIR/nodes
###############################################################################
NODEINDEX=1
NODECOUNT=0

mkdir -p $NODEDIR

if [ -f $SRCNODEFILE ]
then
    NODETOTAL=`cat $SRCNODEFILE | wc -l`
    BUSYNODECOUNT=`ls $NODEDIR | wc -l`
    FREENODECOUNT=`expr $NODETOTAL - $BUSYNODECOUNT`

    if [ "$COMPUTERS" = "all" ]
    then
        COMPUTERS=$FREENODECOUNT
    fi
    echo "COMPUTERS:$COMPUTERS"
    
    if [ $FREENODECOUNT -lt $COMPUTERS ]
    then
        echo "Not enough free nodes" 2>&1
        exit 1
    fi

    rm -f $TESTRUNS_DIR/$TESTRUN/nodes.cfg
    
    while [ $NODECOUNT -lt $COMPUTERS ]
    do
        if ls $NODEDIR/*_node${NODEINDEX}.lck 2>/dev/null 1>&2
        then
            echo NODE $NODEINDEX IS BUSY
        else 
            echo NODE $NODEINDEX IS FREE
            NODEFILE=$NODEDIR/${TESTRUN}_node${NODEINDEX}.lck
            #echo $TESTNAME > $NODEFILE
            head -$NODEINDEX $SRCNODEFILE | tail -1 >> $TESTRUNS_DIR/$TESTRUN/nodes.cfg
            echo NODE $NODEINDEX IS TAKEN: $NODEFILE

            NODECOUNT=`expr $NODECOUNT + 1`
        fi
        
        NODEINDEX=`expr $NODEINDEX + 1`
    done
    echo NODES END
else
    echo "No $SRCNODEFILE" 2>&1
    exit 1
fi

