/*
 * Copyright 2010 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __NETFSM_COORDINATOR_H
#define __NETFSM_COORDINATOR_H
    
#include <atl/string.h>
#include <atl/list.h>

#define CONFIG_DIR   "conf"
#define STARTALL        "startall.sh"
#define ENDALL          "endall.sh"
#define KILLALL         "killall.sh"
#define CLUSTERS_DIR    "clusters"

#define TESTRUNS_DIR "testruns"
#define NODES_OUTFILENAME   "nodes.cfg"
#define LINKS_OUTFILENAME   "links.cfg"


String* init_MCC( const char* config_dir, const char* cluster, const char* testruns_dir, bool keep_connection );
const char* coord_getConfigDir();
const char* coord_getCluster();
const char* coord_getTestRunsDir();

String *coord_StartTest( String *testName, String *testParams
                       , String *nodes, String *topologyType
                       , String *prevTRI, bool saveCP
                       , String **testRunId
                       );

String *coord_StopTest( String *testRunId );

String *KillTest_MCC( String *testRunId );

List   *coord_GetActiveTestRunIds();

int     coord_GetNumberOfNodes( String *testRunId );

String *coord_GetNodeInfo( String *testRunId, int nodeNumber );

String *coord_GetTestRunInfo( String *testRunId );

String *coord_GetInfoAll();

String *getPerrorString( const char *s );

#endif /* __NETFSM_COORDINATOR_H */
